from bike import log

_undoStack = None

def getUndoStack(forceNewStack = 0):
    global _undoStack
    if _undoStack is None or forceNewStack:
        _undoStack = UndoStack()
    return _undoStack

class UndoStackEmptyException: pass

class UndoStack(object):
    def __init__(self):
        self.stack = []
        self.stack.append([])
        self.frame = self.stack[-1]
        self.setUndoBufferSize(10)

    def setUndoBufferSize(self, undoBufferSize):
        self.undoBufferSize = undoBufferSize

    def addSource(self, sourcenode, src):
        #print "addSource1",src        
        if sourcenode not in[snode for snode, src in self.frame]:
            #print "addSource",src
            self.frame.append([sourcenode, sourcenode.getSource()])

    def commitUndoFrame(self):
        #restrict size of buffer
        while len(self.stack) > self.undoBufferSize:
            #print "clipping undo stack"
            del self.stack[0]

        if len(self.frame) != 0:
            #print "commitUndoFrame"
            self.stack.append([])
            self.frame = self.stack[-1]

    def undo(self, **opts):

        #print "undo called",self.stack
        if len(self.stack) < 2:
            raise UndoStackEmptyException()
        undoframe = self.stack[-2]
        #print "undoframe is",undoframe
        for sourcenode, src in undoframe:
            print >>log.progress, "Undoing:",sourcenode.modulename
            sourcenode.reload(src)
            sourcenode.setModified()
        self.stack = self.stack[:-2]
        self.stack.append([])
        self.frame = self.stack[-1]
