from __future__ import generators
from bike.parsing.extended_ast import Source, Instance
from bike.query.common import walkSourceNodes, Match, \
     getReferences, getScopeForLine, MatchFinder
from getTypeOf import getTypeOf, getTypeOfExpr
from bike.parsing.visitor import walk
import compiler
from bike.query.relationships import getAllClassesInHierarchy
from bike import log

def getReferencesToMethod(root,fqn):
    classfqn = fqn.split(".")[:-1]
    methodname = fqn.split(".")[-1]
    classobj = getTypeOf(root,".".join(classfqn))
    print >>log.progress,"Getting all members of class hierarchy"
    targetClasses = getAllClassesInHierarchy(root,classobj)
    print >>log.progress,"class hierarchy done"
    methodRefFinder = MethodRefFinder(targetClasses,methodname)
    for ref in getReferences(root, methodRefFinder, methodname):
        yield ref
    print >>log.progress,"Done"


class MethodRefFinder(MatchFinder):
    def __init__(self,targetClasses,targetMethodName):
        self.targetClasses = targetClasses
        self.targetMethodName = targetMethodName

    def visitGetattr(self, node):
        for c in node.getChildNodes():
            self.visit(c)

        if node.attrname == self.targetMethodName:
            exprtype = getTypeOfExpr(self.scope,node.expr)
            if isinstance(exprtype,Instance) and \
               exprtype.getType() in self.targetClasses:
                self.appendMatch(self.targetMethodName)
            else:
                self.appendMatch(self.targetMethodName,50)
        self.popWordsUpTo(node.attrname)


